#include <stdio.h>

typedef unsigned long dword;
typedef unsigned short word;

struct WAVEheader
{
   char  ckID[4];             /* chunk id 'RIFF'            */
   dword ckSize;              /* chunk size                 */
   char  wave_ckID[4];        /* wave chunk id 'WAVE'       */
   char  fmt_ckID[4];         /* format chunk id 'fmt '     */
   dword fmt_ckSize;          /* format chunk size          */
   word  formatTag;           /* format tag currently pcm   */
   word  nChannels;           /* number of channels         */
   dword nSamplesPerSec;      /* sample rate in hz          */
   dword nAvgBytesPerSec;     /* average bytes per second   */
   word  nBlockAlign;         /* number of bytes per sample */
   word  nBitsPerSample;      /* number of bits in a sample */
   char  data_ckID[4];        /* data chunk id 'data'       */
   dword data_ckSize;         /* length of data chunk       */
};

main(int argc,char **argv)
{
   FILE *fd;
   int length;
   struct WAVEheader w;
   if(argc!=2) {
      fprintf(stderr,"Syntax: %s rawfile\n",argv[0]);
      exit(999);
   }
   fd = fopen(argv[1],"r+");
   if(!fd) {
      fprintf(stderr,"Could not open %s for modification\n",argv[1]);
      exit(999);
   }
   fseek(fd,0,SEEK_END);
   length = ftell(fd);
   printf("File is %d bytes long.\n",length);
   w.ckID[0] = 'R';
   w.ckID[1] = 'I';
   w.ckID[2] = 'F';
   w.ckID[3] = 'F';
   w.wave_ckID[0] = 'W';
   w.wave_ckID[1] = 'A';
   w.wave_ckID[2] = 'V';
   w.wave_ckID[3] = 'E';
   w.fmt_ckID[0] = 'f';
   w.fmt_ckID[1] = 'm';
   w.fmt_ckID[2] = 't';
   w.fmt_ckID[3] = ' ';
   w.data_ckID[0] = 'd';
   w.data_ckID[1] = 'a';
   w.data_ckID[2] = 't';
   w.data_ckID[3] = 'a';
   w.fmt_ckSize = 0x10;
   w.formatTag = 1;
   w.nChannels = 2;
   w.nSamplesPerSec = 44100;
   w.nAvgBytesPerSec = 4 * 44100;
   w.nBlockAlign = 4;
   w.nBitsPerSample = 16;
   w.ckSize = length - 8;
   w.data_ckSize = length - 0x2c;
   printf("Overwriting first %d bytes of it with .wav header\n",sizeof(w));
   fseek(fd,0,SEEK_SET);
   length = fwrite(&w,1,sizeof(w),fd);
   if(length!=sizeof(w)) {
      fprintf(stderr,"Error writing to file\n");
      exit(999);
   }
   fclose(fd);
}
